package u8c.impl.mmpac.mmpac;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;

import org.apache.commons.lang3.StringUtils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;


import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.NCLocator;
import nc.bs.pub.billcodemanage.BillcodeGenerater;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.jcom.lang.StringUtil;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.trade.pub.IBillStatus;
import u8c.bs.servlet.service.BaseServlet;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.log.NcLog;
import u8c.vo.OrderInVO;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;

public class OrderAddImpl extends BaseServlet implements IHttpServletAdaptor{
	BaseDAO dao = new BaseDAO();
	//UserTransaction trans;

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			//trans = NCLocator.getInstance().lookup(UserTransaction.class);
			//trans.begin();//开启事务
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSON.parseObject(createStr);
			//接口返回结果
			JSONObject returnobj = new JSONObject();
			//正常返回json
			JSONArray result = new JSONArray();
			//报错返回json
			JSONArray errMessage = new JSONArray();
			String checkresult = checkJson(json);
			if(checkresult != null){
				errMessage.add(formatRSJsonData("失败",
						checkresult,""));
				returnobj.put("info", "失败");
				returnobj.put("errMessage", checkresult);
				returnobj.put("result", errMessage);
				resp.getWriter().write(returnobj.toString());
				NcLog.info(returnobj.toString());
				return;
			}
			JSONArray bodyArray = json.getJSONArray("result");
			for (Object Object : bodyArray) {

				JSONObject bodyObject = JSONObject.parseObject(Object.toString());
				String pk_corp = bodyObject.getString("pk_corp");
				
				String vbillno = bodyObject.getString("vbillno");
				if(StringUtil.isEmpty(vbillno)) {//如果单据号为空则自动生成
					vbillno=new BillcodeGenerater().getBillCode("55A2",pk_corp, null, null);
				}
				Boolean isrepeat = IsRepeat(vbillno);
				if(isrepeat) {
					result.add(formatRSJsonData("失败","单据号"+vbillno+"重复",""));
//				errMessage.add(formatRSJsonData("失败","单据号"+vbillno+"重复","").toString());
//				returnobj.put("info", "失败");
//				returnobj.put("errMessage", "单据号"+vbillno+"重复");
//				returnobj.put("result", errMessage);
//				resp.getWriter().write(returnobj.toString());
//				NcLog.info(returnobj.toString());
					continue;
				}
				String dbilldate = bodyObject.getString("dbilldate");
				String pk_proposer = GetBaseDAOUtil.getUserid(bodyObject.getString("pk_proposer"));
				if(pk_proposer.equals("")) {
					result.add(formatRSJsonData("失败","制单人"+bodyObject.getString("pk_proposer")+"未查到，请检查",""));
//				errMessage.add(formatRSJsonData("失败","制单人"+bodyObject.getString("pk_proposer")+"未查到，请检查","").toString());
//				returnobj.put("info", "失败");
//				returnobj.put("errMessage", "制单人"+bodyObject.getString("pk_proposer")+"未查到，请检查");
//				returnobj.put("result", errMessage);
//				resp.getWriter().write(returnobj.toString());
//				NcLog.info(returnobj.toString());
					continue;
				}
				String workmanid = GetBaseDAOUtil.getPsndocid(bodyObject.getString("workmanid"));
				String plandeptid = GetBaseDAOUtil.getDeptdocid(bodyObject.getString("plandeptid"));
				String vnote = bodyObject.getString("vnote");
				//String busitype = GetBaseDAOUtil.getBusitypeid(bodyObject.getString("busitype"),pk_corp);
				OrderMainVO headvo = new OrderMainVO();
				//表头赋值
				headvo.setPk_corp(pk_corp);
				headvo.setVbillno(vbillno);
				headvo.setDbilldate(new UFDate(dbilldate));
				headvo.setPk_proposer(pk_proposer);
				headvo.setWorkmanid(workmanid);
				headvo.setPlandeptid(plandeptid);
				headvo.setVnote(vnote);
				headvo.setDef11(bodyObject.getString("projectid"));//项目编码
				headvo.setBillstatus(IBillStatus.FREE);
				//工单号即项目编码
				headvo.setDef1(bodyObject.getString("projectid"));
				//项目
				headvo.setProjectid(GetBaseDAOUtil.getprojectids(bodyObject.getString("projectid")));
				//业务类型
				headvo.setBusitype(bodyObject.getString("busitype"));
				String pk_order = dao.insertVO(headvo);
				//入库赋值
				if(bodyObject.getJSONArray("product")!=null) {
					JSONArray inArray = bodyObject.getJSONArray("product");
					for(int i = 0;i < inArray.size();i++) {
						Object inobj = inArray.get(i);
						JSONObject injsobj = JSONObject.parseObject(inobj.toString());
						String prjcode = injsobj.getString("prjcode");
						String prjname = GetBaseDAOUtil.getprojectname(prjcode);
						String prjtypecode = GetBaseDAOUtil.getprjtypecode(prjcode);
						String prjtypename = GetBaseDAOUtil.getprjtypename(prjcode);
						String vbatchcode = injsobj.getString("vbatchcode");
						String cmaterialcode = injsobj.getString("cmaterialcode");
						String invname = GetBaseDAOUtil.getinvname(cmaterialcode);
						String invspec = GetBaseDAOUtil.getinvspec(cmaterialcode);
						String invtype = GetBaseDAOUtil.getinvtype(cmaterialcode);
						String width = injsobj.getString("width");//宽度
						String height = injsobj.getString("height");//高度
//						String castunitid = GetBaseDAOUtil.getMeasidByName(injsobj.getString("castunitid"));//辅助计量单位
						String castunitid = injsobj.getString("castunitid");//辅助计量单位
						String nastnum = injsobj.getString("nastnum");//辅数量
						String num = injsobj.getString("num");//主数量
						String bdef6 = "";//换算率
						if( (!StringUtils.isEmpty(num)) && (!StringUtils.isEmpty(nastnum)) ) {//判断数量与辅数量不为空计算换算率
							bdef6 = new UFDouble(num).div(new UFDouble(nastnum)).toString();
						}
						String measname = GetBaseDAOUtil.getmeasname(cmaterialcode);
						String bdef11 = injsobj.getString("bdef11");//楼号楼层
						String bdef12 = injsobj.getString("bdef12");//樘数(数量) 
						String bdef13 = injsobj.getString("bdef13");//框统计
						String bdef14 = injsobj.getString("bdef14");//扇统计
						String bdef15 = injsobj.getString("bdef15");//半成品分类
						String bdef16 = injsobj.getString("bdef16");//面积
						String bdef17 = injsobj.getString("bdef17");//切割长度
						String bdef18 = injsobj.getString("bdef18");//切割角度左下
						String bdef19 = injsobj.getString("bdef19");//切割角度右上
						String bdef2 = injsobj.getString("bdef2");//备注
						String bdef20 = injsobj.getString("bdef20");//系列
						String bdef3 = injsobj.getString("bdef3");//玻璃编号
						OrderInVO invo = new OrderInVO();
						invo.setPrjcode(prjcode);;
						invo.setPrjname(prjname);
						invo.setPrjtypecode(prjtypecode);
						invo.setPrjtypename(prjtypename);
						invo.setVbatchcode(vbatchcode);
						invo.setCmaterialcode(cmaterialcode);
						invo.setCmaterialname(invname);
						invo.setSpec(invspec);
						invo.setModel(invtype);
						invo.setWidth(width);
						invo.setHeight(height);
						invo.setCastunitid(castunitid);
						invo.setNastnum(new UFDouble(nastnum));
						invo.setUnitid(measname);
						invo.setPk_order(pk_order);
						invo.setBdef11(bdef11);
						invo.setBdef12(bdef12);
						invo.setBdef13(bdef13);
						invo.setBdef14(bdef14);
						invo.setBdef15(bdef15);
						invo.setBdef16(bdef16);
						invo.setBdef17(bdef17);
						invo.setBdef18(bdef18);
						invo.setBdef19(bdef19);
						invo.setBdef2(bdef2);
						invo.setBdef20(bdef20);
						invo.setBdef3(bdef3);
						invo.setBdef6(bdef6);
						invo.setColor(injsobj.getString("color"));
						invo.setSizing(injsobj.getString("sizing"));
						invo.setAlloy(injsobj.getString("alloy"));
						if(GetBaseDAOUtil.getInvbasdocFree4(cmaterialcode) != null) {
							invo.setStandard("国标");
						}
						invo.setDr(0);
						if(injsobj.getString("num")!=null) {
							invo.setNum(new UFDouble(injsobj.getString("num")));
						}
						dao.insertVO(invo);
					}
				}
				//领料赋值
				if(bodyObject.getJSONArray("issue")!=null) {
					JSONArray issueArray = bodyObject.getJSONArray("issue");
					for(int i = 0;i < issueArray.size();i++) {
						Object issueobj = issueArray.get(i);
						JSONObject issuejsobj = JSONObject.parseObject(issueobj.toString());
						String prjcode = issuejsobj.getString("prjcode");
						String prjname = GetBaseDAOUtil.getprojectname(prjcode);
						String prjtypecode = GetBaseDAOUtil.getprjtypecode(prjcode);
						String prjtypename = GetBaseDAOUtil.getprjtypename(prjcode);
						String vbatchcode = issuejsobj.getString("vbatchcode");
						String cmaterialcode = issuejsobj.getString("cmaterialcode");
						String invname = GetBaseDAOUtil.getinvname(cmaterialcode);
						String invspec = GetBaseDAOUtil.getinvspec(cmaterialcode);
						String invtype = GetBaseDAOUtil.getinvtype(cmaterialcode);
						String width = issuejsobj.getString("width");//宽度
						String height = issuejsobj.getString("height");//高度
//						String castunitid = GetBaseDAOUtil.getMeasidByName(issuejsobj.getString("castunitid"));//辅助计量单位
						String castunitid = issuejsobj.getString("castunitid");//辅助计量单位
						String nastnum = issuejsobj.getString("nastnum");//辅数量
						String num = issuejsobj.getString("num");//主数量
						String bdef6="";//换算率
						if( (!StringUtils.isEmpty(num)) && (!StringUtils.isEmpty(nastnum)) ) {//判断数量与辅数量不为空计算换算率
							bdef6 = new UFDouble(num).div(new UFDouble(nastnum)).toString();
						}
						String measname = GetBaseDAOUtil.getmeasname(cmaterialcode);
						String bdef11 = issuejsobj.getString("bdef11");//楼号楼层
						String bdef12 = issuejsobj.getString("bdef12");//樘数(数量) 
						String bdef13 = issuejsobj.getString("bdef13");//框统计
						String bdef14 = issuejsobj.getString("bdef14");//扇统计
						String bdef15 = issuejsobj.getString("bdef15");//半成品分类
						String bdef16 = issuejsobj.getString("bdef16");//面积
						String bdef17 = issuejsobj.getString("bdef17");//切割长度
						String bdef18 = issuejsobj.getString("bdef18");//切割角度左下
						String bdef19 = issuejsobj.getString("bdef19");//切割角度右上
						String bdef2 = issuejsobj.getString("bdef2");//备注
						String bdef20 = issuejsobj.getString("bdef20");//系列
						String bdef3 = issuejsobj.getString("bdef3");//玻璃编号
//						String standard = GetBaseDAOUtil.getdefdocid(GetBaseDAOUtil.getpk_defdoclist("BZ（标准）"),"国标");//标准
//						String color = GetBaseDAOUtil.getdefdocid(GetBaseDAOUtil.getpk_defdoclist("YS（颜色）"),issuejsobj.getString("color"));//颜色
//						String sizing = GetBaseDAOUtil.getdefdocid(GetBaseDAOUtil.getpk_defdoclist("DC（定尺）"),issuejsobj.getString("sizing"));//定尺
//						String alloy = GetBaseDAOUtil.getdefdocid(GetBaseDAOUtil.getpk_defdoclist("HJ（合金）"),issuejsobj.getString("alloy"));//合金
						OrderIssueVO issuevo = new OrderIssueVO();
						issuevo.setPrjcode(prjcode);;
						issuevo.setPrjname(prjname);
						issuevo.setPrjtypecode(prjtypecode);
						issuevo.setPrjtypename(prjtypename);
						issuevo.setVbatchcode(vbatchcode);
						issuevo.setCmaterialcode(cmaterialcode);
						issuevo.setCmaterialname(invname);
						issuevo.setSpec(invspec);
						issuevo.setModel(invtype);
						issuevo.setWidth(width);
						issuevo.setHeight(height);
						issuevo.setCastunitid(castunitid);
						issuevo.setNastnum(new UFDouble(nastnum));
						issuevo.setUnitid(measname);
						issuevo.setPk_order(pk_order);
						issuevo.setBdef11(bdef11);
						issuevo.setBdef12(bdef12);
						issuevo.setBdef13(bdef13);
						issuevo.setBdef14(bdef14);
						issuevo.setBdef15(bdef15);
						issuevo.setBdef16(bdef16);
						issuevo.setBdef17(bdef17);
						issuevo.setBdef18(bdef18);
						issuevo.setBdef19(bdef19);
						issuevo.setBdef2(bdef2);
						issuevo.setBdef20(bdef20);
						issuevo.setBdef3(bdef3);
						issuevo.setBdef6(bdef6);
						issuevo.setColor(issuejsobj.getString("color"));
						issuevo.setSizing(issuejsobj.getString("sizing"));
						issuevo.setAlloy(issuejsobj.getString("alloy"));
						if(GetBaseDAOUtil.getInvbasdocFree4(cmaterialcode) != null) {
							issuevo.setStandard("国标");
						}
						issuevo.setDr(0);
						if(issuejsobj.getString("num")!=null) {
							issuevo.setNum(new UFDouble(issuejsobj.getString("num")));
						}
						dao.insertVO(issuevo);
					}
				}
				result.add(formatRSJsonData("成功","",vbillno));
			
			}
			//trans.commit();//提交事务
			returnobj.put("info", "成功");
			returnobj.put("errMessage", "");
			returnobj.put("result", result);
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
		} catch (Exception e) {
			try {
				//trans.rollback();
			} catch (Exception e1) {
				e1.printStackTrace();
			}//异常时事务回滚
			JSONArray errMessage = new JSONArray();
			JSONObject returnobj = new JSONObject();
			String emsg = null;
			if(e.getMessage() == null) {
				emsg="空指针";
			}else {
				emsg = e.getMessage().replace("\"", "\'");
			}
			errMessage.add(formatRSJsonData("失败",
					emsg,""));
			returnobj.put("info", "失败");
			returnobj.put("errMessage", emsg);
			returnobj.put("result", errMessage);	
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
			return;
		}
	}

	
	
	/*
	 * 非空判断
	 */
	private String checkJson(JSONObject json) throws Exception {
		
		StringBuffer mags = new StringBuffer();
		Boolean empty = true;
		String body = "result";//表体
		
		if (json.getJSONArray(body)==null) {
			empty = false;
			mags.append("请传入接口数据！ ");
			return mags.toString();
		}
		
		JSONArray oprepObjectBs = json.getJSONArray("result");
		
		String pk_corp = "pk_corp";//组织
		String pk_proposer = "pk_proposer";//制单人
		String dbilldate = "dbilldate";//单据日期
		
		String in = "in";//入库
		String issue = "issue";//领料
		String sc = "sc";//委外
 
		for(int i = 0; i < oprepObjectBs.size(); i++) {
			JSONObject oprepJsonObjectB = oprepObjectBs.getJSONObject(i);
			String[] HeadKey = {pk_corp,pk_proposer,dbilldate};
			int num = i+1;
			
			mags.append("第"+num+"块表头：{");
			for (String as : HeadKey) {

				if (oprepJsonObjectB.getString(as).isEmpty()) {
					empty = false;
					mags.append("'" + as + "' ");
				}
			}
			mags.append("}");
			
			if(oprepJsonObjectB.getJSONArray(in)==null&&oprepJsonObjectB.getJSONArray(issue)==null&&oprepJsonObjectB.getJSONArray(sc)==null) {
				mags.append("第"+num+"块表体不能为空");
			}
		}
		
		
		if (!empty) {
			return "以下字段不可为空："+mags;
		}
		else {
			return null;
		}
	}
	
	private Boolean IsRepeat(String vbillno) throws DAOException {
		String qrysql = "select pk_order from mmpac_order_main where isnull(dr,0) = 0 and vbillno = '"+vbillno+"'";
		String pk_order = (String) dao.executeQuery(qrysql, new ColumnProcessor());
        if (pk_order == null) {
            return Boolean.FALSE;
        }
        return Boolean.TRUE;
	}
}
